import sys
import os
import copy
import time
from collections import deque
from StringIO import StringIO
from multiprocessing import Pool
import multiprocessing

sys.path.append("../../")

from soft.utils.camber_params_utils import *
from soft.utils.camber_utils import *
from soft.utils.camber_io_utils import *
from soft.structs.multigene import *
from alnsoft.structs.aln_filenames import *
from alnsoft.structs.phylo_tree import *
from alnsoft.utils.camber_aln_utils import *
from alnsoft.utils.camber_phylo_utils import *
from alnsoft.utils.camber_phylo_io_utils import *

thr = 0.000000001

def transformTree(tree, clusters_map):
    for leaf_node_id in tree.root.getLeaves():

        leaf_node = tree.nodes[leaf_node_id]
       # print("transform", leaf_node_id, leaf_node.label, tree.nodes_count)
        strains_tmp = list(clusters_map[leaf_node.label].split(" "))
       # print(strains_tmp)
        if len(strains_tmp) == 1:
            leaf_node.label = strains_tmp[0]
            leaf_node.node_id = strains_tmp[0]
      #      print("xxx", leaf_node.label, leaf_node.node_id)
        else:
            for strain_id in strains_tmp:
                #print("here", leaf_node.label, strain_id)
                new_leaf = PhyloTreeNode(strain_id)
                new_leaf.e_len = 0.00001
                new_leaf.label = strain_id
                leaf_node.addChild(new_leaf)
       #     print(leaf_node.label, len(strains_tmp), strains_tmp)
     #   print(leaf_node.node_id, leaf_node.parent.node_id, leaf_node.label)
   # for leaf_node in tree.root.getLeaves():
   #     print("yyy", leaf_node.label)
    return tree

if __name__ == '__main__':
    parameters = overwriteParameters(sys.argv)
    parameters = readParameters(config_aln = True)
    
    phylo_dir = parameters["PHYLOGENY_FOLDER_MUTATIONS"] 
    tree_soft = parameters["TREE_SOFT"]

    print(tree_soft)

    cluster_strains = []
    input_fh = open(phylo_dir + "/clusters_map.txt")
    for line in input_fh.readlines():
        line = line.strip()
        tokens= line.split()
        if len(tokens) >= 1 and len(tokens[0]) >= 1:
            cluster_strains.append(tokens[0])
    input_fh.close()
    
    clusters_map = {}
    input_fh = open(phylo_dir + "/clusters_map.txt")
    for line in input_fh.readlines():
        tokens = line.strip().split("\t")
        clusters_map[tokens[0]] = tokens[1].replace(" ", ",")
    input_fh.close()
    
#    print(cluster_strains.count(), cluster_strains.allStrains())
    
    input_fn = phylo_dir + 'tree_raw_'+tree_soft.lower()+".txt"
    output_fn = phylo_dir + 'tree_'+tree_soft.lower()+".txt"
    input_fh = open(input_fn)
    output_fh = open(output_fn, "w")
    trees = readPhyloTrees(input_fh, strains_list=cluster_strains, strains_map = {})
    tree = trees[0]
  #  print(tree)
  #  print(clusters_map)
    tree = transformTree(tree, clusters_map)
    #print(tree.toString(lengths=True, strains=cluster_strains, int_labels=False))
    flat_tree = tree.flatten(thr)
    #print(flat_tree)
#    print(tree_org.toString(lengths=True, strains=None, int_labels=False))
    text_line = flat_tree.toString(lengths=False, strains=None, int_labels=False) + ";\n"
    output_fh.write(text_line);
    output_fh.close();
    input_fh.close()

    print("t3_resolve_clusters.py. Finished.")
    